//+------------------------------------------------------------------+
//|                                          Engulfing Bar Alert.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Violet


extern bool alertsOn           = false;
extern bool alertsSound        = false;
extern bool alertsMessage      = true;
extern bool alertsNotification = false;
extern bool alertsEmail        = false;

//---- buffers
double Up[],Dn[];

//+------------------------------------------------------------------+

int init()
  {
   SetIndexBuffer(0,Up);
   SetIndexBuffer(1,Dn);
   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   
   
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+

int start() {
   int i, counter;
   double Range, AvgRange;
   int CountBars=Bars;


   for(i=0; i<CountBars; i++)
   
   
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+2;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      
        
        Up[i+1] = EMPTY_VALUE;
        Dn[i+1] = EMPTY_VALUE;
	     //  UP
	     if (Close[i+1]>Open[i+1]&&Close[i+2]<Open[i+2]&&Close[i+1]>Open[i+2]&&Open[i+1]<=Close[i+2])
           {
          	Up[i+1]=Low[i+1]-Range*1.5;
           }
		                                                         
           
        // DOWN
        if (Close[i+1]<Open[i+1]&&Close[i+2]>Open[i+2]&&Close[i+1]<Open[i+2]&&Open[i+1]>=Close[i+2])
           {                               
		      Dn[i+1]=High[i+1]+Range*1.5;
		     } 		          
           
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
         if (Up[1] != EMPTY_VALUE) doAlert(alertType1,alertTime1,"Engulfing bar signal up");
         if (Dn[1] != EMPTY_VALUE) doAlert(alertType1,alertTime1,"Engulfing bar signal Down");
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"Engulfing bar"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"Engulfing bar "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

